JavaJava学习笔记35(十分)

代码在运转中生出的题目就是相当

java中把多种分外封装六个类,当程序出现问题时候,就会创建丰硕类对象并且抛出相关信息

 

不行体系:

Throwable类是Java中存有错误或特其它父类

Throwable的子类Error类是具有错误的父类

Throwable的另一个子类Exception类是富有特另外父类

在付出中,绝对来说,我们并不关注错误,而更关爱分外

不行和不当的区别(通俗解释):

分外:相当于一个人胸闷了,吃药睡觉等开展对应的操作即可痊愈,不改动代码处理掉那一个,程序仍可以够执行

荒唐:相当于一个人得了绝症,无法痊愈,必须修改代码,程序才足以实施

就此可以这么敞亮:大家并不关注患了绝症的人,而会想方法去治愈得了小病的人

示例:‘

package demo;

public class Demo {
    public static void main(String[] args) {
        function1();
        function2();
    }
    public static void function1(){
        //异常
        int[] arr = {1,2};
        System.out.println(arr[3]);
        //输出:
        //Exception in thread "main" java.lang.ArrayIndexOutOfBoundsException: 3
        //at demo.Demo.function1(Demo.java:11)
        //at demo.Demo.main(Demo.java:5)
    }
    public static void function2(){
        //错误
        int[] arr = new int[666666666];
        System.out.println(arr);
        //输出:
        //Exception in thread "main" java.lang.OutOfMemoryError: Java heap space
        //at demo.Demo.function2(Demo.java:19)
        //at demo.Demo.main(Demo.java:6)
    }
}

 

只要这么些被抛出了,后边的次序都不会实施,因而要想办法化解这多少个问题

 

可怜中的关键字throw:

写一段代码,存在空指针非常

package demo;

public class ExceptionDemo {
    public static void main(String[] args) {
        int [] arr = null;
        function(arr);
    }
    public static int function(int[] arr){
        int i = arr[arr.length-1];
        return i;
    }
}

进入throw关键字,抛出十分:

package demo;

public class ExceptionDemo {
    public static void main(String[] args) throws Exception {
        int [] arr = null;
        int i = function(arr);
        System.out.println(i);
    }
    public static int function(int[] arr) throws Exception{
        //如果方法中有异常,需要在方法上声明:throws Exception
        //抛出的类型和声明的异常类应当一致
        //main调用这个方法,也需要加入声明
        if(arr == null){
            //抛出异常,告诉调用者
            //手动抛出异常
            throw new Exception("传递数组不存在");
        }
        if(arr.length == 0){
            throw new Exception("传递的数组中没有元素");
        }
        int i = arr[arr.length-1];
        return i;
    }
}
/*
输出:
Exception in thread "main" java.lang.Exception: 传递数组不存在
at demo.ExceptionDemo.function(ExceptionDemo.java:16)
at demo.ExceptionDemo.main(ExceptionDemo.java:6)
*/

此间注意,如若是运作时非常(RuntimeException),不需要throws注脚 ,

再就是只要发生这种相当,那么必须改代码,否则代码无意义

 

try  catch方法至极处理:

package demo;

public class ExceptionDemo {
    public static void main(String[] args) {
        int[] arr = null;
        try {
            int i = function(arr);
            System.out.println(i);
        } catch (NullPointerException ex) {
            System.out.println(ex);
        } catch (ArrayIndexOutOfBoundsException ex) {
            System.out.println(ex);
        }
        System.out.println("结束");
    }

    public static int function(int[] arr) throws NullPointerException, ArrayIndexOutOfBoundsException {
        if (arr == null) {
            // 手动抛出空指针异常
            throw new NullPointerException("数组不存在");
        }
        if (arr.length < 6) {
            // 手动抛出数组索引越界异常
            throw new ArrayIndexOutOfBoundsException("数组没有6索引");
        }
        return arr[6];
    }
}
/*
输出:
java.lang.NullPointerException: 数组不存在
结束
 */

此地发现,即使先后有特别,不过依旧施行前边的代码,这就是分外处理

 

catch的顺序:

Java,平级:

package demo;/*
 * catch处理的注意事项:
 *   有顺序
 *   当异常是平级的时候,即没有继承关系的时候,没有顺序限制 
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        try {

        } catch (NullPointerException e) {

        } catch (ArrayIndexOutOfBoundsException e) {

        }
    }
}

有继续关系:

package demo;
//有继承关系:越高级的写在越靠后
public class ExceptionDemo {
    public static void main(String[] args) {
        try {

        } catch (NullPointerException ex) {

        } catch (RuntimeException ex) {

        } catch (Exception ex){

        }
    }
}

 

 

finally:

package demo;

//finally:必须执行
//是否有异常都会执行
public class ExceptionDemo {
    public static void main(String[] args) {
        try {
            function(1);
        } catch (Exception ex) {
            System.out.println(ex);
        } finally {
            System.out.println("代码必须执行");
        }
    }

    public static void function(int a) throws Exception {
        if (a == 0) {
            throw new Exception();
        }
        System.out.println(a);
    }
}
//无论传入什么,都会输出:代码必须执行

 

注意事项:

1.父类的主意若是抛出非凡,子类重写后方可不抛出特别,可是子类假诺要抛出特别,这些特此外继承关系不可能超出父类的老大

 

自定义很是:

突发性需要一些自定义的不行,这里做一个示范:

package demo;

public class FuShuException extends RuntimeException {
    public FuShuException(String string){
        super(string);
    }
    public FuShuException(){}
}

package demo;

//设置一个情景,计算两门成绩的平均数,不能为负数
//如果是一个负数,就抛出异常
public class ExceptionDeno {
    public static void main(String[] args) throws FuShuException {
        try {
            int i = function(10, 97);
            System.out.println(i);
        } catch (FuShuException ex) {
            ex.printStackTrace();
        }
    }

    public static int function(int a, int b) throws FuShuException {
        if (a < 0 || b < 0) {
            throw new FuShuException("成绩不为负");
        }
        int sum = a + b;
        return sum / 2;
    }
}

 

相关文章